; GeOShell/theme.jl

(let*
  (
    (font-colors (list "light grey"
                       "black"))
    
    (gripper-image (make-image "gripper.png"))
    (top-image (make-image "top.png"))
    (close-image (make-image "button-up.png"))
    (title-image (list (make-image "inactive-title.png")
                       (make-image "active-title.png")))
    (top-left-image (make-image "top-left.png"))
    (top-left-normal-image (make-image "top-left-normal.png"))
    (top-right-image (make-image "top-right.png"))
    (top-right-normal-image (make-image "top-right-normal.png"))
    (bottom-left-image (make-image "bottom-left.png"))
    (bottom-right-image (make-image "bottom-right.png"))
    (left-image (make-image "left.png"))
    (right-image (make-image "right.png"))

    (frame `(
        ((background . ,left-image)
         (left-edge . -15)
         (top-edge . -0)
         (bottom-edge . 0)
         (class . title))
        ((background . ,top-left-normal-image)
         (left-edge . -15)
         (top-edge . -26)
         (class . title))
        ((background . ,top-right-normal-image)
         (right-edge . -5)
         (top-edge . -26)
         (class . top-right-corner))
        ((background . ,right-image)
         (right-edge . -5)
         (top-edge . 0)
         (bottom-edge .0)
         (class . right-border))
        ((background . ,top-image)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -5)
         (class . bottom-border))
        ((background . ,bottom-left-image)
         (left-edge . -15)
         (bottom-edge . -5)
         (class . title))
        ((background . ,bottom-right-image)
         (right-edge . -5)
         (bottom-edge . -5)
         (class . bottom-right-corner))
        ((background . ,gripper-image)
         (left-edge . -12)
         (top-edge . -14)
         (class . title))
        ((background . ,top-image)
         (top-edge . -26)
         (left-edge . 0)
         (right-edge . 0)
         (class . top-border))
        ((background . ,top-image)
         (top-edge . -5)
         (left-edge . 0)
         (right-edge . 0)
         (class . title))
        ((background . ,close-image)
         (left-edge . -12)
         (top-edge . -23)
         (class . close-button))
        ((background . ,title-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (top-edge . -21)
         (left-edge . 0)
         (right-edge . 0)
         (class . title))
      ))
      
      (shaped-frame `(
        ((background . ,top-left-normal-image)
         (left-edge . -15)
         (top-edge . -26)
         (class . title))
        ((background . ,top-right-normal-image)
         (right-edge . -5)
         (top-edge . -26)
         (class . title))
        ((background . ,top-image)
         (left-edge . 0)
         (right-edge . 0)
         (top-edge . 0)
         (class . title))
        ((background . ,bottom-left-image)
         (left-edge . -15)
         (top-edge . 0)
         (class . title))
        ((background . ,bottom-right-image)
         (right-edge . -5)
         (top-edge . 0)
         (class . title))
        ((background . ,gripper-image)
         (left-edge . -12)
         (top-edge . -14)
         (class . title))
        ((background . ,top-image)
         (top-edge . -26)
         (left-edge . 0)
         (right-edge . 0)
         (class . title))
        ((background . ,top-image)
         (top-edge . -5)
         (left-edge . 0)
         (right-edge . 0)
         (class . title))
        ((background . ,close-image)
         (left-edge . -12)
         (top-edge . -23)
         (class . close-button))
        ((background . ,title-image)
         (foreground . ,font-colors)
         (text . ,window-name)
         (x-justify . 4)
         (y-justify . center)
         (top-edge . -21)
         (left-edge . 0)
         (right-edge . 0)
         (class . title))
      ))
      
      (shaped-transient-frame `(
        ((background . ,left-image)
         (left-edge . -15)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . title))
        ((background . ,top-left-image)
         (left-edge . -15)
         (top-edge . -5)
         (class . title))
        ((background . ,top-right-image)
         (left-edge . 0)
         (top-edge . -5)
         (class . top-right-corner))
        ((background . ,right-image)
         (left-edge . 0)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . title))
        ((background . ,bottom-left-image)
         (left-edge . -15)
         (bottom-edge . -5)
         (class . title))
        ((background . ,bottom-right-image)
         (left-edge . 0)
         (bottom-edge . -5)
         (class . title))
        ((background . ,gripper-image)
         (left-edge . -12)
         (top-edge . 7)
         (class . title))
        ((background . ,close-image)
         (left-edge . -12)
         (top-edge . -2)
         (class . close-button))
      ))     
      
      (transient-frame `(
        ((background . ,left-image)
         (left-edge . -15)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . title))
        ((background . ,top-left-image)
         (left-edge . -15)
         (top-edge . -5)
         (class . title))
        ((background . ,top-right-image)
         (right-edge . -5)
         (top-edge . -5)
         (class . top-right-corner))
        ((background . ,right-image)
         (right-edge . -5)
         (top-edge . 0)
         (bottom-edge . 0)
         (class . right-border))
        ((background . ,top-image)
         (left-edge . 0)
         (right-edge . 0)
         (bottom-edge . -5)
         (class . bottom-border))
        ((background . ,bottom-left-image)
         (left-edge . -15)
         (bottom-edge . -5)
         (class . title))
        ((background . ,bottom-right-image)
         (right-edge . -5)
         (bottom-edge . -5)
         (class . bottom-right-corner))
        ((background . ,gripper-image)
         (left-edge . -12)
         (top-edge . 7)
         (class . title))
        ((background . ,top-image)
         (top-edge . -5)
         (left-edge . 0)
         (right-edge . 0)
         (class . top-border))
        ((background . ,close-image)
         (left-edge . -12)
         (top-edge . -2)
         (class . close-button))
      ))
    )

  (add-frame-style 'geOShell
    (lambda (w type)
      (cond 
            ((eq type 'shaped) shaped-frame)
            ((eq type 'transient) transient-frame)
            ((eq type 'shaped-transient) shaped-transient-frame)
            ((eq type 'unframed) nil-frame)
            (t frame))))            
)
